  
from PythonSetup import *
import myGlobals
import myVisualization
import myBenchmark
import myDirectory
import mySolver

class myWidgets:
    def __init__(self, ampl, myAMPL, basesnapshot):
        self.ampl=ampl
        self.myAMPL=myAMPL
        self.basesnapshot=basesnapshot

    ## Button Widgets
    def on_btnClear_clicked(self, b):   
        ampl=self.ampl
        with self.Dataset_out:
            self.Dataset_out.clear_output()

            if self.InputUpload.value != {}:                          
                self.InputUpload.data.clear()
                self.InputUpload.metadata.clear()
                self.InputUpload.set_state({'_counter': 0})
                self.InputUpload.send_state()

                ampl.eval('reset data;')

                print('\033[1m', '\n ------Selected files cleared------ \n','\033[0m')

                self.SystemComponentsSelect.options = []
                self.SystemComponents_grid.children = ()
                self.RecoveryPointSelect.options = []
                self.BenchmarkSelect.options = []
                self.ObjSelect.options = []
                self.ConstraintSelect.options = []

                with self.SystemComponents_out:
                    self.SystemComponents_out.clear_output()          
                with self.SystemDependency_out:
                    self.SystemDependency_out.clear_output()
                with self.Recovery_out:
                    self.Recovery_out.clear_output()
                with self.Solver_out:
                    self.Solver_out.clear_output()

    btnClear = widgets.Button(
        description='Clear Selected Files',
        disabled=False,
        button_style='danger',
        tooltip='Click to clear selected files',
        icon='')

    def on_btnPreview_clicked(self, b):
        with self.Dataset_out:
            self.Dataset_out.clear_output()
            if self.SheetSelect.value == ():
                print('\033[1m', '\n ------No sheet selected------ \n','\033[0m')
            else:
                df = pd.read_excel(self.InputUpload.value[self.InputFileSelect.value]['content'], list(self.SheetSelect.value))
                display(df)

    btnPreview = widgets.Button(
        description='Preview',
        disabled=False,
        button_style='info',
        tooltip='Click to preview',
        icon='search')
    
    def on_btnUpload_clicked(self, b):
        ampl=self.ampl
        myAMPL=self.myAMPL
        
        with self.Dataset_out:
            self.Dataset_out.clear_output()

            if self.InputUpload.value == {}:
                print('\033[1m', '\n ------No file selected------ \n','\033[0m')
            else:
                ampl.eval('reset data;')

                mySolver.Configure(ampl)

                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'P',index_col=0)),'P')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'I',index_col=0)),'I')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'IX',index_col=[0,1])),'IX')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'OX',index_col=[0,1])),'OX')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'DLNK',index_col=[0,1])),'DLNK')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'LNK',index_col=[0,1,2])),'LNK')
                ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'PRC',index_col=[0,1,2])),'')
#                 ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'E',index_col=0)),'E')
#                 ampl.setData(DataFrame.fromPandas(pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'L',index_col=[0,1])),'')

                # temporary until have Haz model dump loadings
                df1=pd.read_excel(self.InputUpload.value['CommunityData.xlsx']['content'],'E',index_col=0)
                df1.reset_index(drop=False, inplace=True)
                df1['key']=0
                df2=myAMPL.getData('I')
                df2.reset_index(drop=False, inplace=True)
                df2['key']=0
                df_new=df2.merge(df1, how='outer')
                df_new.drop(columns=['key','PR'], inplace = True)
                df_new.rename(columns={"LE": "L"}, inplace = True)
                df1.drop(columns=["LE","key"],inplace=True)
                df1.set_index('E',inplace=True)
                ampl.setData(df1,'E')
                df_new.set_index(['I','E'],inplace=True)
                ampl.setData(df_new,'')

                self.SystemComponentsSelect.options = ['Sets', 'Parameters']  
                self.SetDisplay.options = [re.sub("[<>].*[>]","",ampl.getValue('alias(' + s.name() + ')')) + '(' + s.name() + ')' for index, s in ampl.getSets()]
                self.ParamDisplay.options = [re.sub("[<>].*[>]","",ampl.getValue('alias(' + p.name() + ')')) + '(' + p.name() + ')' for index, p in ampl.getParameters()]
                self.LayoutSelect.options = ['manual', 'circular', 'kamada_kawai', 'random', 'shell', 'spring', 'spectral', 'spiral']
                self.LayoutSelect.value = 'manual'
                self.RecoveryPointSelect.options = ampl.getData('I').toList()
                
                os.makedirs(myGlobals.datapath, exist_ok=True)
                myDirectory.Clear(myGlobals.solpath)

                print('\033[1m', '\n ------Input files loaded------ \n','\033[0m')

                with self.SystemDependency_out:
                    self.SystemDependency_out.clear_output()
                    
    btnUpload = widgets.Button(
        description='Upload',
        disabled=False,
        button_style='warning',
        tooltip='Click to Upload',
        icon='check')
                    
    def on_btnSystemComponents_clicked(self, b):
        myAMPL = self.myAMPL
        with self.SystemComponents_out:
            self.SystemComponents_out.clear_output()
            if self.InputUpload.value != {}:
                if self.SystemComponentsSelect.value == 'Sets':
                    display(myAMPL.getData(re.search('\((.*?)\)', self.SetDisplay.value).groups()[0]))
                elif self.SystemComponentsSelect.value == 'Parameters':
                    display(myAMPL.getData(re.search('\((.*?)\)', self.ParamDisplay.value).groups()[0]))

    btnSystemComponents = widgets.Button(
        description='Display',
        disabled=False,
        button_style='warning',
        tooltip='Click to display system components',
        icon='pencil')

    def on_btnSystemGraph_clicked(self, b): 
        ampl = self.ampl
        basesnapshot = self.basesnapshot
        Visualize = myVisualization.myVisualization(ampl, basesnapshot)
        with self.SystemDependency_out:
            self.SystemDependency_out.clear_output()

            if self.InputUpload.value != {}:
                if self.LayoutSelect.value == 'manual' and self.CoordinatesUpload.value == {}:
                    print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')
                else:
                    fig, edges, edges_hover, nodes, layouts = Visualize.NetworkViz(Visualize.nxGraph(), self.LayoutSelect.value)
                    edges = Visualize.dashed_DLNK(edges)

                    edges_hover.on_hover(Visualize.edge_hover_fn)
                    nodes.on_hover(Visualize.node_hover_fn)

                    if self.ImagesUploadCheckBox.value == True:
                        if self.ImageUpload.value == {}:
                            print('\033[1m', '\n ------No images uploaded------ \n','\033[0m')
                        else:
                            display(widgets.VBox([widgets.HBox([fig, 
                                                                self.image_widgets]),
                                                  Visualize.node_details,
                                                  Visualize.edge_details]))
                    else:
                        display(widgets.VBox([fig, 
                                              Visualize.node_details, 
                                              Visualize.edge_details]))

    btnSystemGraph = widgets.Button(
        description='Display',
        disabled=False,
        button_style='warning',
        tooltip='Click to display system dependency',
        icon='pencil')

    def on_btnRecovery_clicked(self, b): 
        ampl = self.ampl
        with self.Recovery_out:
            self.Recovery_out.clear_output()

            if self.InputUpload.value != {}:
                p=ampl.getParameter('restor_end').set(self.RecoveryPointSelect.value)
                print('\033[1m', f'\n ------The recovery end point is set to be {self.RecoveryPointSelect.value}------ \n','\033[0m')

                self.ObjSelect.options = ['Minimize the EV recovery time', 'Minimize the EV total cost']
                self.BenchmarkSelect.options = ['Do Nothing', 'Unlimited Budget']

    btnRecovery = widgets.Button(
        description='Set',
        disabled=False,
        button_style='warning',
        tooltip='Click to Upload',
        icon='')

    def on_btnSolve_clicked(self, b):
        ampl = self.ampl
        myAMPL = self.myAMPL
        basesnapshot = self.basesnapshot

        with self.Solver_out:
            self.Solver_out.clear_output()

            if self.InputUpload.value != {}:

                if self.Solver_accordion.selected_index == 0:  

                    if self.BenchmarkSelect.value == 'Do Nothing':
                        myBenchmark.DoNothing_Scenario(ampl)
                    elif self.BenchmarkSelect.value == 'Unlimited Budget':
                        myBenchmark.UnlimitedBudget_Scenario(ampl)

                elif self.Solver_accordion.selected_index == 1:

                    if self.ObjSelect.value == 'Minimize the EV recovery time':
                        ampl.eval('objective RecoveryDisutilityObjectiveFxn;')
                    elif self.ObjSelect.value == 'Minimize the EV total cost':
                        ampl.eval('objective EV_TotalCostObjectiveFxn;')

                    if self.ConstraintSelect.value == 'Total expected costs upper limit':
                        ampl.getParameter('EV_TotalCost_OVERBRACE').set(self.BudgetSelect.value)
                    elif self.ConstraintSelect.value == 'Total expected recovery time upper limit':
                        ampl.getParameter('RecoveryDisutility_OVERBRACE').set(self.RecoveryTimeSelect.value) 

                if self.Solver_accordion.selected_index != None:
                    b.button_style='warning'

                    isoptimal = mySolver.Run(ampl)
                    if isoptimal:
                        myAMPL.WriteSolution(myGlobals.solpath, myDirectory.unusedfname(myGlobals.solpath,'<newSolution>'))   #########   recent add'n
                        myDirectory.refresh_selSolutions(myGlobals.solpath, self.selSolutions)

                    b.button_style=self.get_button_style(ampl.getValue('solve_result'))
                    tooltip_msg='Size: '+str(int(ampl.getValue('_nvars'))) + ' variables, ' \
                    +  str(int(ampl.getValue('_ncons'))) + ' constraints.' \
                    + "\n" + 'Solve result: \'' + ampl.getValue('solve_result').title() +'\''
                    b.tooltip = tooltip_msg
                    if os.path.isfile(myGlobals.solpath):
                        self.selSolutions.options=myDirectory.listFilesInDirectory(myGlobals.solpath)

                    myAMPL.dropAllFixes()
                    myAMPL.resetToSnapshot(basesnapshot)

                self.CustomConstraintCheckBox.value = False

    btnSolve = widgets.Button(
        description='Run Solver',
        disabled=False,
        button_style='info',
        tooltip='Click to run the solver',
        icon='')

    def on_btnRename_clicked(self, b):
        with self.Solver_out:
            self.Solver_out.clear_output()

            if self.InputUpload.value != {}:        
                if self.selSolutions.value == ():
                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                else:
                    if len(self.selSolutions.value)>1:
                        print('\033[1m', '\n ------Select only one file at a time------ \n','\033[0m')
                    else:
                        if self.NameChange.value == '':
                            print('\033[1m', '\n ------Type the new file name ------ \n','\033[0m')
                        else:
                            for fname in myDirectory.listFilesInDirectory(myGlobals.solpath):
                                if self.NameChange.value == fname:
                                    print('\033[1m', f'\n ------Type a new file name. "{self.NameChange.value}" already exist------ \n','\033[0m')
                                    return
                            os.rename(f'{myGlobals.solpath}/{self.selSolutions.value[0]}',
                                      f'{myGlobals.solpath}/{self.NameChange.value}')
                            self.selSolutions.options = myDirectory.listFilesInDirectory(myGlobals.solpath)

    btnRename = widgets.Button(
        description='Rename',
        disabled=False,
        button_style='info',
        tooltip='Click to rename the selected file',
        icon='')

    def on_btnDelete_clicked(self, b):
        with self.Solver_out:
            self.Solver_out.clear_output()

            if self.InputUpload.value != {}:        
                if self.selSolutions.value == ():
                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                else:
                    for i in range(len(self.selSolutions.value)):   
                        os.remove(f'{myGlobals.solpath}/{self.selSolutions.value[i]}')

                self.selSolutions.options = myDirectory.listFilesInDirectory(myGlobals.solpath)

    btnDelete = widgets.Button(    
        description='Delete',
        disabled=False,
        button_style='info',
        tooltip='Click to delete selected solutions',
        icon='')

    def on_btnSave_clicked(self, b):
        myAMPL = self.myAMPL
        with self.Solver_out:
            self.Solver_out.clear_output()

            if self.InputUpload.value != {}:
                if self.selSolutions.value == ():
                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                else: 
                    if self.SolutionDirectorySelect.value == '':
                        print('\033[1m', '\n ------Specify the name of the folder where you want to save the solutions------ \n','\033[0m')
                    else:
                        savedsolpath = f'./CaseStudies/SavedSolutions/{self.SolutionDirectorySelect.value}'
                        os.makedirs(savedsolpath, exist_ok=True) 
                        for index in range(len(self.selSolutions.value)):
                            copyfile(f'{myGlobals.solpath}/{self.selSolutions.value[index]}',f'{savedsolpath}/{self.selSolutions.value[index]}')
                        print('\033[1m', '\n ------Selected solutions saved on the following directory:------ \n','\033[0m',savedsolpath)

    btnSave = widgets.Button(
        description='Save',
        disabled=False,
        button_style='info',
        tooltip='Click to save selected solutions',
        icon='')

    def on_btnDisplayResults_clicked(self, b):
        ampl = self.ampl
        myAMPL = self.myAMPL      
        basesnapshot = self.basesnapshot
        
        Visualize = myVisualization.myVisualization(ampl, basesnapshot)

        with self.Plotter_out:
            self.Plotter_out.clear_output()

            if self.InputUpload.value != {}:        
                if self.selSolutions.value == ():
                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                else:
                    if self.Results_accordion.selected_index == 0:

                        b.button_style='warning'
                        Visualize.TopLevelTable(myAMPL, myGlobals.solpath, self.selSolutions.value)
                        b.button_style='success'

                    elif self.Results_accordion.selected_index == 1:

                        if self.Stages_tab.selected_index == 0:

                            if self.ChartSelect.value == 'Bar Chart': 
                                if self.selSolutions.value == {}:
                                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                                else:
                                    b.button_style='warning'
                                    Visualize.MitigationStageBarChart(myAMPL, myGlobals.solpath, self.selSolutions.value)
                                    b.button_style='success'

                            elif self.ChartSelect.value == 'Graph':
                                if self.selSolutions.value == {}:
                                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                                else:
                                    if self.LayoutSelect.value == 'manual' and self.CoordinatesUpload.value == {}:
                                        print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')
                                    else:
                                        b.button_style='warning'
                                        Visualize.MitigationStageGraph(myAMPL, myGlobals.solpath, self.selSolutions.value)
                                        b.button_style='success'

                        elif self.Stages_tab.selected_index == 1:

                            if self.ChartSelect.value == 'Bar Chart':
                                if self.selSolutions.value == {}:
                                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                                else:
                                    b.button_style='warning'                        
                                    Visualize.RecoveryStageBarChart(myAMPL, myGlobals.solpath, self.selSolutions.value)
                                    b.button_style='success'

                            elif self.ChartSelect.value == 'Graph':
                                if self.selSolutions.value == {}:
                                    print('\033[1m', '\n ------No solution selected------ \n','\033[0m')
                                else:
                                    if self.LayoutSelect.value == 'manual' and self.CoordinatesUpload.value == {}:
                                        print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')
                                    else:
                                        b.button_style='warning'
                                        Visualize.RecoveryStageGraph(myAMPL, myGlobals.solpath, self.selSolutions.value)
                                        b.button_style='success'

    btnDisplayResults = widgets.Button(
        description='Display',
        disabled=False,
        button_style='warning',
        tooltip='Click to display graph',
        icon='pencil')

    def on_btnDisplayTradeoff_clicked(self, b):
        ampl = self.ampl
        myAMPL = self.myAMPL
        basesnapshot = self.basesnapshot
        Visualize = myVisualization.myVisualization(ampl, basesnapshot)

        with self.Tradeoff_out:
            self.Tradeoff_out.clear_output()

            if self.InputUpload.value != {}:
                EV_TotalCost        = []
                RecoveryDisutility  = []   
                Number_of_Scenarios = 100

                myBenchmark.DoNothing_Scenario(ampl)
                mySolver.Run(ampl)
                Initial_EV_TotalCost = ampl.getValue('EV_TotalCost') + 0.1

                myAMPL.dropAllFixes()        

                myBenchmark.UnlimitedBudget_Scenario(ampl)
                mySolver.Run(ampl)
                Final_EV_TotalCost = ampl.getValue('EV_TotalCost')

                EV_TotalCost_Increment = (Final_EV_TotalCost - Initial_EV_TotalCost)/Number_of_Scenarios

                myAMPL.resetToSnapshot(basesnapshot)

                for n in range(Number_of_Scenarios+1):
                    ampl.eval('objective RecoveryDisutilityObjectiveFxn;')
                    ampl.getParameter('EV_TotalCost_OVERBRACE').set(Initial_EV_TotalCost + EV_TotalCost_Increment*n)
                    mySolver.Run(ampl)

                    EV_TotalCost.append(ampl.getValue('EV_TotalCost'))
                    RecoveryDisutility.append(ampl.getValue('RecoveryDisutility'));

                fig = Visualize.GraphViz(EV_TotalCost, RecoveryDisutility, 
                               myAMPL.getEntityInfo(ampl.getVariable("EV_TotalCost")).ampl_alias, 
                               myAMPL.getEntityInfo(ampl.getVariable("RecoveryDisutility")).ampl_alias,
                               "")
                display(fig)

                myAMPL.dropAllFixes()
                myAMPL.resetToSnapshot(basesnapshot)

    btnDisplayTradeoff = widgets.Button(
        description='Display',
        disabled=False,
        button_style='warning',
        tooltip='Click to display trade-off curve',
        icon='pencil')
    
    ## File Upload Widgets

    InputUpload = widgets.FileUpload(accept="", multiple=True, description='Select Files')
    
    def handle_InputUpload_change(self, change):
        self.InputFileSelect.options = [fname for fname in self.InputUpload.value.keys()]

    CoordinatesUpload = widgets.FileUpload(accept='', description='Upload', multiple=True)
    
    def handle_CoordinatesUpload_change(self, change):
        if self.CustomConstraintCheckBox.value == True:
            with self.Solver_out:
                self.Solver_out.clear_output() 
                self.AddAdditionalConstraint()

    ImageUpload = widgets.FileUpload(accept='image/*', description='Upload', multiple=True)
    
    def handle_ImageUpload_change(self, change):
        if self.ImagesUploadCheckBox.value == True:
            self.Images_grid.children = (self.ImageUpload,)
        else: 
            self.Images_grid.children = ()
            
    image_widgets = widgets.Image(layout=Layout(height='auto', width='auto')) 
    
    ## Select Widgets
    
    InputFileSelect = widgets.RadioButtons(
        options=[],
        disabled=False)

    def handle_InputFileSelect_change(self, change):
        if self.InputUpload.value == {}:
            self.SheetSelect.options = []
        else:
            self.SheetSelect.options = [shname for shname in pd.read_excel(self.InputUpload.value[self.InputFileSelect.value]['content'],None).keys()]
            
    SheetSelect = widgets.SelectMultiple(
        options=[],
        value=[],
        disabled=False)     
         
    SetDisplay = widgets.Dropdown(
        options=[],
        description='Set:',
        disabled=False)
    
    ParamDisplay = widgets.Dropdown(
        options=[],
        description='Parameter:',
        disabled=False)
    
    SystemComponentsSelect = widgets.RadioButtons(
        options=[],
        description = ' ',
        disabled=False)

    def handle_SystemComponentsSelect_change(self, change):
        ampl=self.ampl
        with self.SystemComponents_out:
            self.SystemComponents_out.clear_output()
        if self.SystemComponentsSelect.value == 'Sets':
            self.SystemComponents_grid.children = (self.SetDisplay,)
        elif self.SystemComponentsSelect.value == 'Parameters': 
            self.SystemComponents_grid.children = (self.ParamDisplay,)
            
    ImagesUploadCheckBox = widgets.Checkbox(
        value=False,
        description='Show Images',
        disabled=False,
        indent=False)
    
    LayoutSelect = widgets.Dropdown(
        options = [],
        disabled = False,
        description='Select Layout:', 
        style = {'description_width': 'initial'}, 
        layout = Layout(display='flex', flex_flow='row', align_items='stretch', width='15%'))

    def handle_LayoutSelect_change(self, change):
        if self.LayoutSelect.value == 'manual':
            self.Coordinates_grid.children = (self.CoordinatesUpload,)
        else:
            self.Coordinates_grid.children = ()

        if self.LayoutSelect.value == 'manual' and self.CoordinatesUpload.value == {}:
            with self.SystemDependency_out:
                self.SystemDependency_out.clear_output()
                print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')

            if self.CustomConstraintCheckBox.value == True:  
                with self.Solver_out:
                    print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')                    
        else:
            with self.Solver_out:
                self.Solver_out.clear_output()  
                self.AddAdditionalConstraint()
    
    RecoveryPointSelect = widgets.Dropdown(
        options=[],
        disabled=False)
        
    BenchmarkSelect = widgets.RadioButtons(
        options=[], 
        description=' ')
    
    ObjSelect = widgets.Dropdown(
        options=[], 
        description='Obj Fxn:')

    def handle_ObjSelect_change(self, change):
        if self.ObjSelect.value == 'Minimize the EV recovery time':
            self.ConstraintSelect.options = ['Total expected costs upper limit']
            self.Constraint_grid.children = (widgets.HBox([widgets.Label('Cost Upper Limit:',style={'description_width': 'initial'}), 
                                                           self.BudgetSelect]),)
        elif self.ObjSelect.value == 'Minimize the EV total cost':
            self.ConstraintSelect.options = ['Total expected recovery time upper limit']
            self.Constraint_grid.children = (widgets.HBox([widgets.Label('Recovery Time Upper Limit:',style={'description_width': 'initial'}), 
                                                           self.RecoveryTimeSelect]),)  
            
    ConstraintSelect = widgets.Dropdown(
        options=[],
        disabled=False, 
        description='Constraints:')

    def handle_ConstraintSelect_change(self, change):
        self.CustomConstraintCheckBox.value = False
    
    BudgetSelect = widgets.FloatSlider(
        min=0, max=10000000, value=500000.0, step=10000, readout=True, 
        readout_format='$,', description=' ', style = {'description_width': 'initial'})

    RecoveryTimeSelect = widgets.FloatSlider(
        min=0, max=15, value=1, step=0.1, readout=True, description=' ', style = {'description_width': 'initial'})

    CustomConstraintCheckBox = widgets.Checkbox(
        value=False,
        description='Add additional constraint',
        disabled=False,
        indent=False)

    def handle_CustomConstraintCheckBox_change(self, change):
        ampl = self.ampl
        myAMPL = self.myAMPL
        basesnapshot = self.basesnapshot
        with self.Solver_out: 
            self.Solver_out.clear_output()
            if self.CustomConstraintCheckBox.value == True:          
                if self.LayoutSelect.value == 'manual':
                    self.Coordinates_grid.children = (self.CoordinatesUpload,)
                else:
                    self.Coordinates_grid.children = () 

                if self.LayoutSelect.value == 'manual' and self.CoordinatesUpload.value == {}:
                    self.CustomConstraint_grid.children = (widgets.HBox([self.LayoutSelect,
                                                                         self.Coordinates_grid]),)
                    print('\033[1m', '\n ------No coordinates loaded. Select another layout or upload the coordinates------ \n','\033[0m')
                else:
                    self.AddAdditionalConstraint()
            else: 
                myAMPL.dropAllFixes()
                myAMPL.resetToSnapshot(basesnapshot)

                self.CustomConstraint_grid.children = ()

    CustomVarSelect = widgets.RadioButtons(
        options=['Mitigation cost [$]', 'Increase in resistance [ft]'],
        description='Select a variable:',
        disabled=False,
        style = {'description_width': 'initial'}, 
        layout=Layout(display='flex', flex_flow='row', align_items='stretch', width='20%'))

    astatusSelect = widgets.ToggleButtons(
        options=['Fix', 'Bound', 'No restrictions'],
        value = 'No restrictions',
        disabled=False,
        button_style='',
        style = {'description_width': 'initial'})

    def handle_astatusSelect_change(self, change):
        if self.astatusSelect.value == 'Fix':
            self.Bound_grid.children = (self.fixValueSelect,)
        elif self.astatusSelect.value == 'Bound':
            self.Bound_grid.children = (widgets.HBox([self.CustomLbSelect, self.CustomUbSelect]),)
        elif self.astatusSelect.value == 'No restrictions':
            self.Bound_grid.children = ()

    fixValueSelect = widgets.FloatText(
        placeholder='The fix value',
        disabled=False,
        continuous_update=True,
        description='Fix value:',
        style = {'description_width': 'initial'}, 
        layout=Layout(display='flex', flex_flow='row', align_items='stretch', width='10%'))

    CustomLbSelect = widgets.FloatText(
        placeholder='The lower bound',
        disabled=False,
        continuous_update=True,
        description='Lower bound:',
        style = {'description_width': 'initial'}, 
        layout=Layout(display='flex', flex_flow='row', align_items='stretch', width='10%'))

    CustomUbSelect = widgets.FloatText(
        placeholder='The upper bound',
        disabled=False,
        continuous_update=True,
        description='Upper bound:',
        style = {'description_width': 'initial'}, 
        layout=Layout(display='flex', flex_flow='row', align_items='stretch', width='10%'))            

    selSolutions = widgets.SelectMultiple(
        description='Solutions:',
        options=[],
        disabled=False)

    NameChange = widgets.Text(
        disabled=False,
        continuous_update=True)
    
    SolutionDirectorySelect = widgets.Text(
        placeholder='Type something',
        disabled=False)
    
        
    ChartSelect = widgets.RadioButtons(
        options=['Bar Chart', 'Graph'],
        description='Chart Type:',
        disabled=False)

    def handle_ChartSelect_change(self, change):
        if self.ChartSelect.value == 'Bar Chart':
            with self.Plotter_out:
                self.Plotter_out.clear_output()
            self.Plotter_grid.children = (self.selSolutions,)  
        elif self.ChartSelect.value == 'Graph':
            with self.Plotter_out:
                self.Plotter_out.clear_output()
            self.Plotter_grid.children = (widgets.VBox([widgets.HBox([self.LayoutSelect, 
                                                                      self.Coordinates_grid]),
                                                        self.selSolutions]),)

    ## Output Widgets
    
    Dataset_out = widgets.Output(layout={'border': '1px solid black'})
    
    SystemComponents_out = widgets.Output(layout={'border': '1px solid black'})
        
    SystemDependency_out = widgets.Output(layout={'border': '1px solid black'})
    
    Recovery_out = widgets.Output(layout={'border': '1px solid black'})

    Solver_out = widgets.Output(layout={'border': '1px solid black'})

    Plotter_out = widgets.Output(layout={'border': '1px solid black'})

    Tradeoff_out = widgets.Output(layout={'border': '1px solid black'})

    ## Grid Box Widgets 

    SystemComponents_grid = widgets.GridBox()
    
    Coordinates_grid = widgets.GridBox([CoordinatesUpload])

    Images_grid = widgets.GridBox()

    Constraint_grid = widgets.GridBox()

    CustomConstraint_grid = widgets.GridBox()

    Bound_grid = widgets.GridBox()

    Plotter_grid = widgets.GridBox([selSolutions])
    

    ## Accordion Widgets

    Dataset_accordion = widgets.Accordion(children=[widgets.HBox([InputUpload, btnClear]),
                                                    widgets.VBox([widgets.HBox([widgets.Label('Select File:',style={'description_width': 'initial'}),
                                                                                InputFileSelect]),
                                                                  widgets.HBox([widgets.Label('Select Sheet:',style={'description_width': 'initial'}),
                                                                                SheetSelect]),
                                                                  btnPreview])])

    Dataset_accordion.set_title(0, 'Select')
    Dataset_accordion.set_title(1, 'Preview')

    Solver_accordion = widgets.Accordion()
    Solver_accordion.children=[BenchmarkSelect,
                               widgets.VBox([ObjSelect,
                                             widgets.HBox([ConstraintSelect,
                                                           Constraint_grid]),
                                             CustomConstraintCheckBox,
                                             CustomConstraint_grid])]

    Solver_accordion.set_title(0, 'Benchmark Solution')
    Solver_accordion.set_title(1, 'Custom Solution')

    Stages_tab = widgets.Tab(style = {'description_width': 'initial'}) 
    Stages_tab.children = [widgets.VBox([ChartSelect,
                                         Plotter_grid]), 
                           widgets.VBox([ChartSelect,
                                         Plotter_grid])]

    Stages_tab.set_title(0, 'Mitigation')
    Stages_tab.set_title(1, 'Recovery')

    Results_accordion = widgets.Accordion(children=[selSolutions,
                                                    Stages_tab])

    Results_accordion.set_title(0, 'Top Level Info')
    Results_accordion.set_title(1, 'Detailed Info')

    ## Tab Widgets

    Dataset_tab = widgets.VBox([Dataset_accordion,
                                btnUpload,
                                Dataset_out])

    SystemComponents_tab = widgets.VBox([widgets.HBox([widgets.Label('Select System Component:', style={'description_width': 'initial'}),
                                                       SystemComponentsSelect]),
                                         SystemComponents_grid,
                                         btnSystemComponents,
                                         SystemComponents_out])

    SystemDependency_tab = widgets.VBox([widgets.HBox([LayoutSelect, 
                                                       Coordinates_grid]),
                                         widgets.HBox([ImagesUploadCheckBox, 
                                                       Images_grid]),
                                         btnSystemGraph,
                                         SystemDependency_out])

    Recovery_tab = widgets.VBox([widgets.HBox([widgets.Label('Select Recovey End Point:', style={'description_width': 'initial'}),
                                               RecoveryPointSelect]),
                                 btnRecovery,
                                 Recovery_out])

    Solver_tab = widgets.VBox([Solver_accordion,
                               btnSolve,
                               widgets.HBox([selSolutions,
                                             widgets.VBox([widgets.HBox([btnRename,
                                                                         widgets.Label('Type new name:',style={'description_width': 'initial'}),
                                                                         NameChange]),
                                                           btnDelete,
                                                           widgets.HBox([btnSave, 
                                                                         widgets.HBox([widgets.Label('Specify the name of the folder where you want to save the solutions:',style={'description_width': 'initial'}),
                                                                                       SolutionDirectorySelect])])])]),
                               Solver_out])                           

    Results_tab = widgets.VBox([Results_accordion,
                                btnDisplayResults,
                                Plotter_out])  

    Tradeoff_tab = widgets.VBox([btnDisplayTradeoff,
                                 Tradeoff_out])  

    Understand_the_Situation = widgets.Tab(style = {'description_width': 'initial'}) 
    Understand_the_Situation.children = [Dataset_tab, SystemComponents_tab, SystemDependency_tab]
    Understand_the_Situation.set_title(0, 'Input Dataset')
    Understand_the_Situation.set_title(1, 'System Components')
    Understand_the_Situation.set_title(2, 'System Dependency')

    Interactive_Solver = widgets.Tab(style = {'description_width': 'initial'}) 
    Interactive_Solver.children = [Recovery_tab, Solver_tab, Results_tab]
    Interactive_Solver.set_title(0, 'Define Recovery')
    Interactive_Solver.set_title(1, 'Run Solver')
    Interactive_Solver.set_title(2, 'Results')

    Tools = widgets.Tab(style = {'description_width': 'initial'}) 
    Tools.children = [Tradeoff_tab]
    Tools.set_title(0, 'Trade-off Curve')
    
    # Widgets Functions

    def AddAdditionalConstraint(self): 
        ampl = self.ampl
        myAMPL = self.myAMPL
        basesnapshot = self.basesnapshot
        Visualize = myVisualization.myVisualization(ampl, basesnapshot)

        if self.CustomConstraintCheckBox.value == True:
            fig, edges, edges_hover, nodes, layouts = Visualize.NetworkViz(Visualize.nxGraph(), self.LayoutSelect.value)
            edges = Visualize.dashed_DLNK(edges)
            nodes.marker.colorbar = None
            nodes.marker.showscale = False
            nodes.marker.color = ['navy']*len(Visualize.nxGraph().nodes()) 

            def node_click_fn(trace, points, selector):
                with self.Solver_out:
                    color = list(nodes.marker.color)
                    size = list(nodes.marker.size)

                    for index in points.point_inds:
                        color[index] = 'red'
                        size[index] = 20

                        node = ampl.getData('I').toList()[index]

                        if self.astatusSelect.value == 'Fix':
                            for i, e in ampl.getVariables():
                                if self.CustomVarSelect.value == ampl.getValue('alias(' + e.name() + ')'):                                
                                    if myAMPL.isDefinitionalVariable(e): 
                                        ampl.eval(f'let MCLIMIT_lb["{node}"]:={self.fixValueSelect.value};')
                                        ampl.eval(f'let MCLIMIT_ub["{node}"]:={self.fixValueSelect.value + 0.00001};')
                                    else:                                        
                                        ampl.getVariable(f'{e.name()}').get(node).fix(self.fixValueSelect.value)

                            with fig.batch_update():
                                nodes.marker.color = color
                                nodes.marker.size = size
                            print('\033[1m', f'\n ------The {self.CustomVarSelect.value} for {node} is fixed to be {self.fixValueSelect.value}------ \n','\033[0m')

                        elif self.astatusSelect.value == 'Bound':
                            for i, e in ampl.getVariables():
                                if self.CustomVarSelect.value == ampl.getValue('alias(' + e.name() + ')'):
                                    if self.CustomVarSelect.value == 'Mitigation cost [$]':
                                        ampl.eval(f'let MCLIMIT_lb["{node}"]:={self.CustomLbSelect.value};')
                                        ampl.eval(f'let MCLIMIT_ub["{node}"]:={self.CustomUbSelect.value};')
                                    elif self.CustomVarSelect.value == 'Increase in resistance [ft]':
                                        ampl.eval(f'let RLIMIT_lb["{node}"]:={self.CustomLbSelect.value};')
                                        ampl.eval(f'let RLIMIT_ub["{node}"]:={self.CustomUbSelect.value};')

                            with fig.batch_update():
                                nodes.marker.color = color
                                nodes.marker.size = size

                            print('\033[1m', f'\n ------The {self.CustomVarSelect.value} for {node} is set to be in ({self.CustomLbSelect.value}, {self.CustomUbSelect.value}) range------ \n','\033[0m')

                        elif self.astatusSelect.value == 'No restrictions':
                            for i, e in ampl.getVariables():
                                if self.CustomVarSelect.value == ampl.getValue('alias(' + e.name() + ')'):
                                    if ampl.getVariable(f'{e.name()}').get(node).astatus() == 'fix':
                                        ampl.getVariable(f'{e.name()}').get(node).unfix()
                                    else:
                                        if self.CustomVarSelect.value == 'Mitigation cost [$]':
                                            ampl.eval(f'let MCLIMIT_lb["{node}"]:={0};')
                                            ampl.eval(f'let MCLIMIT_ub["{node}"]:={float("inf")};')
                                        elif self.CustomVarSelect.value == 'Increase in resistance [ft]':
                                            ampl.eval(f'let RLIMIT_lb["{node}"]:={0};')
                                            ampl.eval(f'let RLIMIT_ub["{node}"]:={ampl.getData("R_OVERBRACE").toDict()[node]};')

                                    color[index] = 'navy'
                                    size[index] = 15
                            with fig.batch_update():
                                nodes.marker.color = color
                                nodes.marker.size = size
                            print('\033[1m', f'\n ------There is no restriction for {node}------ \n','\033[0m') 

            nodes.on_click(node_click_fn)

            self.CustomConstraint_grid.children = (widgets.VBox([widgets.HBox([self.LayoutSelect,
                                                                               self.Coordinates_grid]),
                                                                 self.CustomVarSelect,
                                                                 self.astatusSelect,
                                                                 self.Bound_grid,
                                                                 fig]),)
       
    def get_button_style(self, r):
        if r == 'solved':
            return 'success'
        elif r == 'solved?':
            return 'warning'
        elif r == 'infeasible':
            return 'danger'
        elif r == 'unbounded':
            return 'danger'
        elif r == 'limit':
            return 'danger'
        elif r == 'failure':
            return 'danger'
        else:
            return 'danger'
        

    def Events(self):        
        self.LayoutSelect.observe(self.handle_LayoutSelect_change, names='value')
        self.InputFileSelect.observe(self.handle_InputFileSelect_change, names='value')
        self.ConstraintSelect.observe(self.handle_ConstraintSelect_change, names='value')
        self.InputUpload.observe(self.handle_InputUpload_change, names='value')
        self.ObjSelect.observe(self.handle_ObjSelect_change, names='value')
        self.SystemComponentsSelect.observe(self.handle_SystemComponentsSelect_change, names='value')
        self.CustomConstraintCheckBox.observe(self.handle_CustomConstraintCheckBox_change, names='value')
        self.CoordinatesUpload.observe(self.handle_CoordinatesUpload_change, names='value')
        self.astatusSelect.observe(self.handle_astatusSelect_change, names='value')
        self.ImagesUploadCheckBox.observe(self.handle_ImageUpload_change, names='value')
        self.ChartSelect.observe(self.handle_ChartSelect_change, names='value')

        self.btnClear.on_click(self.on_btnClear_clicked)
        self.btnPreview.on_click(self.on_btnPreview_clicked)
        self.btnSystemComponents.on_click(self.on_btnSystemComponents_clicked)
        self.btnSystemGraph.on_click(self.on_btnSystemGraph_clicked)
        self.btnRecovery.on_click(self.on_btnRecovery_clicked)
        self.btnSolve.on_click(self.on_btnSolve_clicked)
        self.btnRename.on_click(self.on_btnRename_clicked)
        self.btnDelete.on_click(self.on_btnDelete_clicked)
        self.btnSave.on_click(self.on_btnSave_clicked)
        self.btnDisplayResults.on_click(self.on_btnDisplayResults_clicked)
        self.btnDisplayTradeoff.on_click(self.on_btnDisplayTradeoff_clicked)
        self.btnUpload.on_click(self.on_btnUpload_clicked)
